diff --git a/htdocs/images/16-arrow-down.png b/htdocs/images/16-arrow-down.png
deleted file mode 100644
index fa0ff7b3204cde4110c41b9c907896325697401f..0000000000000000000000000000000000000000
GIT binary patch
diff --git a/htdocs/images/16-arrow-up.png b/htdocs/images/16-arrow-up.png
deleted file mode 100644
index 60c4eb9cff183104e4a0c7dfa2699bc1d6dfd88a..0000000000000000000000000000000000000000
GIT binary patch
diff --git a/patchwork/templates/patchwork/patch-list.html b/patchwork/templates/patchwork/patch-list.html
index 4b3cb23..cd691ae 100644
--- a/patchwork/templates/patchwork/patch-list.html
+++ b/patchwork/templates/patchwork/patch-list.html
@@ -53,14 +53,9 @@
    <th>
     {% ifequal order.name "name" %}
      <a class="colactive"
-      href="{% listurl order=order.reversed_name %}"><img
-      {% if order.reversed %}
-      src="{% static "images/16-arrow-up.png" %}"
-      {% else %}
-      src="{% static "images/16-arrow-down.png" %}"
-      {%endif%}
-      width="16" height="16"
-     ></a> <a class="colactive"
+      href="{% listurl order=order.reversed_name %}"><span
+	      class="glyphicon glyphicon-chevron-{{ order.updown }}"
+      ></span></a> <a class="colactive"
       href="{% listurl order=order.reversed_name %}">Patch</a>
     {% else %}
      {% if not order.editable %}
@@ -80,14 +75,9 @@
    <th>
     {% ifequal order.name "date" %}
      <a class="colactive"
-      href="{% listurl order=order.reversed_name %}"><img
-      {% if order.reversed %}
-      src="{% static "images/16-arrow-up.png" %}"
-      {% else %}
-      src="{% static "images/16-arrow-down.png" %}"
-      {%endif%}
-      width="16" height="16"
-     ></a> <a class="colactive"
+      href="{% listurl order=order.reversed_name %}"><span
+	      class="glyphicon glyphicon-chevron-{{ order.updown }}"
+      ></span></a> <a class="colactive"
       href="{% listurl order=order.reversed_name %}">Date</a>
     {% else %}
      {% if not order.editable %}
@@ -101,14 +91,9 @@
    <th>
     {% ifequal order.name "submitter" %}
      <a class="colactive"
-      href="{% listurl order=order.reversed_name %}"><img
-      {% if order.reversed %}
-      src="{% static "images/16-arrow-up.png" %}"
-      {% else %}
-      src="{% static "images/16-arrow-down.png" %}"
-      {%endif%}
-      width="16" height="16"
-     ></a> <a class="colactive"
+      href="{% listurl order=order.reversed_name %}"><span
+	      class="glyphicon glyphicon-chevron-{{ order.updown }}"
+      ></span></a> <a class="colactive"
       href="{% listurl order=order.reversed_name %}">Submitter</a>
     {% else %}
      {% if not order.editable %}
@@ -122,14 +107,9 @@
    <th>
     {% ifequal order.name "delegate" %}
      <a class="colactive"
-      href="{% listurl order=order.reversed_name %}"><img
-      {% if order.reversed %}
-      src="{% static "images/16-arrow-up.png" %}"
-      {% else %}
-      src="{% static "images/16-arrow-down.png" %}"
-      {%endif%}
-      width="16" height="16"
-     ></a> <a class="colactive"
+      href="{% listurl order=order.reversed_name %}"><span
+	      class="glyphicon glyphicon-chevron-{{ order.updown }}"
+      ></span></a> <a class="colactive"
       href="{% listurl order=order.reversed_name %}">Delegate</a>
     {% else %}
      {% if not order.editable %}
@@ -143,14 +123,9 @@
    <th>
     {% ifequal order.name "state" %}
      <a class="colactive"
-      href="{% listurl order=order.reversed_name %}"><img
-      {% if order.reversed %}
-      src="{% static "images/16-arrow-up.png" %}"
-      {% else %}
-      src="{% static "images/16-arrow-down.png" %}"
-      {%endif%}
-      width="16" height="16"
-     ></a> <a class="colactive"
+      href="{% listurl order=order.reversed_name %}"><span
+	      class="glyphicon glyphicon-chevron-{{ order.updown }}"
+      ></span></a> <a class="colactive"
       href="{% listurl order=order.reversed_name %}">State</a>
     {% else %}
      {% if not order.editable %}
diff --git a/patchwork/utils.py b/patchwork/utils.py
index 0dfe8dc..d69cb21 100644
--- a/patchwork/utils.py
+++ b/patchwork/utils.py
@@ -93,6 +93,11 @@ class Order(object):
         else:
             return '-' + self.order
 
+    def updown(self):
+        if self.reversed:
+            return 'up'
+        return 'down'
+
     def apply(self, qs):
         q = self.order_map[self.order]
         if self.reversed: